#include <stdio.h>

#define STOP(x) {printf("\n x \n"); exit();}
#define stop(x) {printf("\n" x "\n"); exit(99);}

#define RADIUS  6371.0
#define PI   3.14159265358979312
#define D double
#define F float

#define MAXS 64
#define NPAR 5

extern float *farray1();
extern float spl();
extern void free_farray1();

/******************************************/
void main()
{
  char disc[4][6],string[40],string2[40],string1[40];
  float *coef;
  FILE *fp,*A1pf;
  int maxs[NPAR],nkw[NPAR],nku[NPAR],nkl[NPAR],nknots,wfcn,nblocks;
  int ndis,rmax,jump,hmax[NPAR],mdim,vjump,i,p,nn,k,ipar,jump0,iv,first;
  float mindep,maxdep,fac,x,r,*mdl,*knot,lat,lon;
char block[NPAR];


  if((fp=fopen("SAW16AN.g3d","r"))==0)
    STOP(anis_A1grid: Cannot open model file);

 fscanf(fp,"%d",&nblocks);
  for(k=0;k<nblocks;k++){
    fscanf(fp,"%d",&maxs[k]);
    fscanf(fp,"%d",&nkw[k]);
    fscanf(fp,"%d",&nku[k]);
    fscanf(fp,"%d",&nkl[k]);
    fscanf(fp,"%d",&wfcn);
    fscanf(fp,"%s",&block[k]);
    if(maxs[k]>MAXS) STOP(gridanis: maxs too large);
    if(wfcn==0)printf("Warning; may be Legendre parameterization\n");
  }
  fscanf(fp,"%d",&ndis);

  if((A1pf=fopen("spl_1500km.par","r"))==0)  
 	STOP(anis_A1grid: Cannot open A1.par file);

  ndis=0;

  disc[0][0]=disc[1][0]=disc[2][0]=disc[3][0]='\0'; 
  if(ndis)
  { printf(";  Discontinuities:");
    for(i=0;i<ndis;i++)
    { fscanf(fp,"%s",disc[i]);
      printf(" %s",disc[i]);
    }
  }



  printf("\n");
  fscanf(A1pf,"%d",&nknots);
  if(nknots!=nkw[0]+nku[0]+nkl[0]+3)stop("dimension error in knots"); 
  knot=farray1(0,nknots-1);
  /* printf(" \n knot position at depth km :");*/
  for(i=0;i<nknots;i++)
  { fscanf(A1pf,"%f",&knot[i]);   
  /*  printf("%.2f ",6371-knot[i]); */
    }   
  printf(" \n");
  fclose(A1pf);


  mindep=RADIUS-knot[nknots-1];
  maxdep=RADIUS-knot[0];
 
  printf(" Depth range: [%.3f %3.f] km",mindep,maxdep);


/*
  printf("\n Enter parameter to plot: L(SV)  or  N(SH)");
  scanf("%s",string); */


  mdim=0;
  
  for(k=0;k<nblocks;k++) {
    hmax[k]=(maxs[k]+1)*(maxs[k]+1);
    mdim+=hmax[k]*(nknots);
  }
  



  first=1;
  do {
    printf(" Specify a depth,"); 
    printf(" or 'q' to quit: ");
    scanf("%s",string);
    if(string[0]=='q')break;
    else  {
      sscanf(string,"%f",&r);
      if(r<mindep||r>maxdep)
	STOP(anis_A1grid: error! depth not in model range);
      r=RADIUS-r;  

      printf("longitude (0,+360)   latitude (-90,+90)\n");
      do{
	printf("\nlon & lat of grid or 'q' to quit: ");
	scanf("%s",string1);
	if(string1[0]=='q')break;
	scanf("%s",string2);

	sscanf(string1,"%f",&lon);
	sscanf(string2,"%f",&lat);      
 
  printf("\n%g\t%g\t",lon,lat);


	for(k=0;k<nblocks;k++) {
	  jump0=0; 
	  
	  if(first) {
	    mdim+=hmax[0]*ndis;       
	    mdl=farray1(0,mdim-1);
	    for(i=0;i<mdim;i++) fscanf(fp,"%g",&mdl[i]);
	    fclose(fp);
	    first=0;
	  }

	  ipar=k;
	  if(ipar>0)jump0+=hmax[k]*(nknots);             

	  coef=farray1(0,hmax[ipar]-1);

    
	  
	  for(i=0;i<hmax[ipar];i++) coef[i]=0.;
	  for(p=0;p<nknots;p++){
	    fac=100*spl(p,nknots,knot,r);  /* percentage */
	    for(i=0;i<hmax[ipar];i++) coef[i]+=fac*mdl[jump0+i+p*hmax[ipar]]; 
	  }

	  
	  if(string[0]!='q')string[0]='\0';
	  harmogrid1(maxs[ipar],coef,"X^",lat,lon);
	  free_farray1(coef,0);
	  
	}      
    } while(string1[0]!='q');  
  }

  } while(string[0]!='q');
  
  free_farray1(mdl,0);

}
